
Redmine - Defect #37407

REST API Issues.xml call returning 204 no content

2022-07-13 00:30 - Daniel Gramza

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version:    

Resolution: Wont fix Affected version: 4.2.4

Description

I'm helping to convert a customer from old redmine version 2.5.3 to 4.2.4

They have a custom spreadsheet with VBA/Macros making updates to Issues in Redmine via REST API and issues.xml call. The

spreadsheet has multiple issue records in it that need to be updated from status "new" to status "part pulled"

When the routine runs to update the first issue record I see the query come into redmine in the production.log as seen below. 

Redmine responds with code "204 no content". This query works fine in the old version of redmine but not in the new version.  Need

some help here. I blanked out the key for security purposes.

The record status is actually successfully updated in redmine oddly enough for the first issue record in the list.  so maybe this is just a

simple return code bug? The spreadsheet VBA/Macro gets the bad return code and bombs out.  The remaining records in the

spreadsheet don't get updated in Redmine then.  I can provide the spreadsheet info if necessary.

There are some custom fields in this deployment but not a ton.

Started PUT "/issues/18610.xml?key=##########################" for 65.28.190.233 at 2022-07-12 17:

48:55 -0400

Processing by IssuesController#update as XML

  Parameters: {"issue"=>{"status_id"=>"11", "description"=>nil, "custom_fields"=>[{"id"=>"2", "val

ue"=>"False"}, {"id"=>"3", "value"=>nil}, {"id"=>"4", "value"=>nil}, {"id"=>"5", "value"=>nil}, {"

id"=>"6", "value"=>nil}, {"id"=>"9", "value"=>nil}, {"id"=>"10", "value"=>nil}]}, "key"=>"########

########################", "id"=>"18610"}

  Current user: Michael (id=4)

Completed 204 No Content in 123ms (ActiveRecord: 38.8ms)

 
Environment:

  Redmine version                4.2.4.stable.21431

  Ruby version                   2.7.2-p137 (2020-10-01) [x86_64-linux]

  Rails version                  5.2.6.2

  Environment                    production

  Database adapter               Mysql2

  Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

  Mailer delivery                smtp

SCM:

  Subversion                     1.13.0

  Git                            2.25.1

  Filesystem                     

Redmine plugins:

  redmine_banner                 0.3.4

  redmine_close_button           0.0.8

  redmine_contacts               4.3.4

  redmine_dmsf                   2.4.11

  redmine_wktime                 4.5

  view_customize                 3.0.0

Related issues:

Related to Redmine - Defect #30073: Ajax Request Returns 200 but an error eve... Closed

History

#1 - 2022-07-13 13:06 - Holger Just
- Description updated

#2 - 2022-07-13 13:13 - Holger Just

- Status changed from New to Closed

- Resolution set to Wont fix

HTTP 204 is the status code sent for successful updates against the REST API.

This was changed following #30073 as the HTTP response does not contain any content. As such, the previous HTTP 200 was incorrect and the

current HTTP 204 status is correct and workds as intended. For the client, both status codes indicate a success.

Your spreadsheet may need to be updated to understand and allow an HTTP 204 response code.

#3 - 2022-07-13 13:14 - Holger Just

- Related to Defect #30073: Ajax Request Returns 200 but an error event is fired instead of success added
